// ragdoll script in, WOOOOOOOOT! :P
#include <acknex.h> // include for Pure Mode
#include <default.c> // default key functions

//#define PRAGMA_PATH "bodyparts";

VECTOR Hinge1, Hinge2;

var GroupID = 2;
var low_rot_dist = 5;

// update bone to hinge
void updateBoneHinge(ENTITY* hingeEnt, STRING* bodyPart, ENTITY* actor) {
	VECTOR temp_pos, temp_ang, temp_mov, temp_ang_1;

	ENTITY* hingePointer = hingeEnt;
	ENTITY* actorPointer = actor;
	STRING* updatePart = bodyPart;
	
	while(hingePointer) {
		// reset bone position
		ent_bonereset(actorPointer, updatePart);
		
		vec_for_bone(temp_pos, actorPointer, updatePart);
		ang_for_bone(temp_ang, actorPointer, updatePart);
		
		vec_set(temp_mov, hingePointer.x);
		vec_sub(temp_mov, temp_pos);
		
		temp_mov.x /= actorPointer.scale_x; temp_mov.y /= actorPointer.scale_y; temp_mov.z /= actorPointer.scale_z;
	//	vec_rotateback (temp_mov, temp_ang);///change this please
		temp_ang.x = 360-temp_ang.x; temp_ang.y = 360-temp_ang.y; temp_ang.z = 360-temp_ang.z;
		
		vec_set(temp_ang_1, nullvector);
		ang_add(temp_ang_1, vector(temp_ang.x,0,0));
		ang_add(temp_ang_1, vector(0,temp_ang.y,0));
		ang_add(temp_ang_1, vector(0,0,temp_ang.z));
		
		ang_rotate(temp_ang_1, hingePointer.pan);
		ent_bonerotate(you, updatePart, temp_ang_1);
		ent_bonemove(you, updatePart, temp_mov);	
		
		wait(1);
	} 
}

// set rotation limits
void setLimit(VECTOR* vec1, VECTOR* vec2) {
	vec_set(Hinge1, vec1);
	vec_set(Hinge2, vec2);
}

// initialise physics and hinges
void BodyPartInit(var mass, ENTITY* entityMe) {	
	set(entityMe, PASSABLE);
	
	entityMe.pan = 180;

	phent_settype(entityMe, PH_RIGID, PH_BOX);
	phent_setmass(entityMe, mass, PH_BOX);
	
	phent_setgroup(entityMe, GroupID);
	phent_setfriction(entityMe, 15);
	phent_setdamping(entityMe, 35, 35);
	phent_setelasticity(entityMe, 35, 30); // bounciness
	
	reset(entityMe, PASSABLE);
}

void setHinge(ENTITY* constr_1, ENTITY* constr_2) {
	var tempHinge;
	
	// make constraint
	tempHinge = phcon_add(PH_HINGE, constr_1, constr_2); // attach to bodypart
	phcon_setparams1(tempHinge, constr_1.x, Hinge1, nullvector); // set hinge limits
	phcon_setparams2(tempHinge, Hinge2, nullvector, nullvector);    // same
}

void setRagdollPart() {
	set(my, INVISIBLE);
}

void SpawnRagdoll() {
	ENTITY* Ent_1;
	ENTITY* Ent_2;
	ENTITY* Ent_3;
	
	GroupID += 1;
	
	var tempVertex;
	
	// create ragdoll actor
	you = ent_create("bodyparts/test_ragdoll.mdl", nullvector, NULL);
	set(you, PASSABLE);
	
	// go on creating the ragdoll PE objects
	Ent_1 = my;
	setRagdollPart();
	BodyPartInit(20, Ent_1); // create physics object and set weight
		// make constraint
		setHinge(Ent_1, Ent_1);
	
	// left upper leg
	vec_for_vertex(tempVertex, Ent_1, 23); // get vertex to attach limb to
 	Ent_2 = ent_create("bodyparts/leg_up_left.mdl", tempVertex, setRagdollPart); // create bodypart
 	setLimit(vector(1,1,1), vector(-40,40,0)); // set rotational boundaries
	BodyPartInit(5, Ent_2); // same as before, and from here keeps copying, but for different limbs every time
		// make constraint
		setHinge(Ent_2, Ent_1);
		updateBoneHinge(Ent_2, "leg_up_left", you);
		
 	// left lower leg
 	vec_for_vertex(tempVertex, Ent_2, 9);
	Ent_3 = ent_create("bodyparts/leg_down_left.mdl", tempVertex, setRagdollPart);
	setLimit(vector(0,1,0), vector(0,120,0));
	BodyPartInit(20, Ent_3);
		// make constraint
		setHinge(Ent_3, Ent_2);
		updateBoneHinge(Ent_3, "leg_down_left", you);
 
	// right upper leg
	vec_for_vertex(tempVertex, Ent_1, 22);
 	Ent_2 =	ent_create("bodyparts/leg_up_right.mdl", tempVertex, setRagdollPart);
 	setLimit(vector(1,1,1), vector(-40,40,0));
	BodyPartInit(5, Ent_2);
		// make constraint
		setHinge(Ent_2, Ent_1);
		updateBoneHinge(Ent_2, "leg_up_right", you);
		
	// right lower leg
	vec_for_vertex(tempVertex, Ent_2, 9);
 	Ent_3 =	ent_create("bodyparts/leg_down_right.mdl", tempVertex, setRagdollPart);
 	setLimit(vector(0,1,0), vector(0,120,0));
	BodyPartInit(20, Ent_3);
		// make constraint
		setHinge(Ent_3, Ent_2);
		updateBoneHinge(Ent_3, "leg_down_right", you);
	
	// abs
	vec_for_vertex(tempVertex, Ent_1, 21);
	Ent_2 = ent_create("bodyparts/abs.mdl", tempVertex, setRagdollPart);
	setLimit(vector(1,1,0), vector(-15,15,0));
	BodyPartInit(20, Ent_2);
		// make constraint
		setHinge(Ent_2, Ent_1);
		updateBoneHinge(Ent_2, "stomach", you);
	
	//torso
	vec_for_vertex(tempVertex, Ent_2, 17);
	Ent_1 = ent_create("bodyparts/torso.mdl", tempVertex, setRagdollPart);
	setLimit(vector(1,1,0), vector(-20,20,0));
	BodyPartInit(55, Ent_1);
		// make constraint
		setHinge(Ent_1, Ent_2);
		updateBoneHinge(Ent_1, "torso", you);
	
	// left upper arm
	vec_for_vertex(tempVertex, Ent_1, 21);
 	Ent_2 = ent_create("bodyparts/arm_up_left.mdl", tempVertex, setRagdollPart);
 	setLimit(vector(1,1,1), vector(-70, 116,20));
	BodyPartInit(5, Ent_2);
		// make constraint
		setHinge(Ent_2, Ent_1);
		updateBoneHinge(Ent_2, "arm_up_left", you);
		
	// left lower arm
	vec_for_vertex(tempVertex, Ent_2, 9);
 	Ent_3 = ent_create("bodyparts/arm_down_left.mdl", tempVertex, setRagdollPart);
 	setLimit(vector(1,1,0), vector(270,0,0));
	BodyPartInit(20, Ent_3);
		// make constraint
		setHinge(Ent_3, Ent_2);
		updateBoneHinge(Ent_3, "arm_down_left", you);

	// right upper arm
	vec_for_vertex(tempVertex, Ent_1, 22);
 	Ent_2 = ent_create("bodyparts/arm_up_right.mdl", tempVertex, setRagdollPart);
 	setLimit(vector(1,1,1), vector(-70,116,20));
	BodyPartInit(5, Ent_2);
		// make constraint
		setHinge(Ent_2, Ent_1);
		updateBoneHinge(Ent_2, "arm_up_right", you);
		
	// right lower arm
	vec_for_vertex(tempVertex, Ent_2, 9);
 	Ent_3 = ent_create("bodyparts/arm_down_right.mdl", tempVertex, setRagdollPart);
 	setLimit(vector(1,1,0), vector(270,0,0));
	BodyPartInit(20, Ent_3);
		// make constraint
		setHinge(Ent_3, Ent_2);
		updateBoneHinge(Ent_3, "arm_down_right", you);
		
		// head
	vec_for_vertex(tempVertex, Ent_1, 23);
	Ent_2 = ent_create("bodyparts/head.mdl", tempVertex, setRagdollPart);
	setLimit(vector(1,1,0), vector(-45,45,0));
	BodyPartInit(25, Ent_2);
		// make constraint
		setHinge(Ent_2, Ent_1);
		updateBoneHinge(Ent_2, "head", you);
	
	while(you) {
		vec_set(you.x, my.x);
		vec_set(you.pan, my.pan);
		
		if(key_space) {
			phent_addvelglobal(my, vector(0,0,500), nullvector);		// THIS ADDS A FORCE TO THE RAGDOLL
		}
		
		wait(1);
	}
}

void main() {
	// vector nullifying
	vec_set(Hinge1, nullvector);
	vec_set(Hinge2, nullvector);
	
	fps_max = 60;
	
	time_smooth = 0;
	ph_iterations = 20; // set itterating physics to smooth out.
	
	level_load("test_level.wmb");
	wait(5);
	
	ph_setgravity(vector(0, 0, -1200)); // set gravity
	ph_setcorrections(9000, 0); // set physics corrections
	ph_setcollisions(1000, 2);
	
	while (1) {
		if (mouse_left) {
			ent_create("bodyparts/pelvis.mdl", vector(0, 0, 400), SpawnRagdoll); // spawn ragdoll initial bodypart
			while(mouse_left){wait(1);}
		}
		wait(1);
	}
}